-- Panic Tracker by Fluffies
-- EU - Weel of Eternity
local addonName, addonTable = ...
local L = addonTable.L

-- v1.0.0
addonTable.version = 1000

local addon_stuff = {}
 addon_stuff["hps"] = {list = {}, target_height = 0}
 addon_stuff["dps"] = {list = {}, target_height = 0}
local barspeed = 5
local barheight = 200

local function BarUpdate(k)
 local fps = GetFramerate()
 barspeed = fps <= 8 and 15 or (fps <= 15 and 10 or 5)

 local tab = addon_stuff[k]
 if not tab then return end

 local t = GetTime()
 local q = 0

 local i = 1
 while i <= table.getn(tab.list) do
  if tab.list[i].t < t then
   table.remove(tab.list, i)
  else
   q = q + tab.list[i].q
   i = i + 1
  end
 end

 -- adding player's total absorbs to the healed amount
 q = q + (k == "hps" and UnitGetTotalAbsorbs("player") or 0)
 
 local ehp = UnitHealthMax("player")
 tab.target_height = math.min(100, (q * 100 / ehp)) * 2
 local curr_height
 if PTracker_Saves.orientation then
  curr_height = tab.frame.foreground:GetHeight()
 else
  curr_height = tab.frame.foreground:GetWidth()
 end
 local h = tab.target_height > curr_height and curr_height + barspeed or curr_height - barspeed
 if PTracker_Saves.orientation then
  tab.frame.foreground:SetHeight(math.abs(tab.target_height - h) <= barspeed and tab.target_height or h)
 else
  tab.frame.foreground:SetWidth(math.abs(tab.target_height - h) <= barspeed and tab.target_height or h)
 end
end

local function GenerateBars()
 local function createbar()
  local obj = CreateFrame("FRAME", nil, UIParent)
  --obj:SetClampedToScreen(true)
  obj:SetPoint("CENTER",UIParent,"CENTER")
  obj:SetWidth(25)
  obj:SetHeight(barheight + 6)

  obj.background = obj:CreateTexture(nil, "BACKGROUND")
  obj.background:SetParent(obj)
  obj.background:SetAllPoints()
  obj.background:SetTexture(0,0,0,0.5)

  obj.foreground = obj:CreateTexture(nil, "ARTWORK")
  obj.foreground:SetParent(obj)
  obj.foreground:SetPoint("BOTTOMLEFT", obj, "BOTTOMLEFT", 3, 3)
  obj.foreground:SetPoint("BOTTOMRIGHT", obj, "BOTTOMRIGHT", -3, 3)
  obj.foreground:SetHeight(0)
 
  return obj
 end -- createbar func
 
 addon_stuff.anchorframe = CreateFrame("Frame", "PTracker_AnchorFrame", UIParent)
 addon_stuff.anchorframe:SetSize(60, 20)
 addon_stuff.anchorframe:EnableMouse(true)
 addon_stuff.anchorframe:SetMovable(true)
 addon_stuff.anchorframe:SetClampedToScreen(true)
 addon_stuff.anchorframe.tex = addon_stuff.anchorframe:CreateTexture()
 addon_stuff.anchorframe.tex:SetAllPoints()
 addon_stuff.anchorframe.tex:SetTexture(0,1,0,0.6)
 addon_stuff.anchorframe.text = addon_stuff.anchorframe:CreateFontString()
 addon_stuff.anchorframe.text:SetAllPoints()
 addon_stuff.anchorframe.text:SetFont("Fonts\\ARIALN.ttf", 16, "")
 addon_stuff.anchorframe.text:SetText("|cff000000Drag to move|r")

 addon_stuff.anchorframe:SetScript("OnMouseDown", function(self, button)
  if button == "LeftButton" and not addon_stuff.anchorframe.isMoving then
   addon_stuff.anchorframe:StartMoving()
   addon_stuff.anchorframe.isMoving = true
  end
 end)
 addon_stuff.anchorframe:SetScript("OnMouseUp", function(self, button)
  if button == "LeftButton" and addon_stuff.anchorframe.isMoving then
   addon_stuff.anchorframe:StopMovingOrSizing()
   addon_stuff.anchorframe.isMoving = false
   local a1, p, a2, x, y = addon_stuff.anchorframe:GetPoint()
   PTracker_Saves.anchor = {a1, p, a2, x, y}
  elseif button == "RightButton" then
   PTracker_Saves.locked = 1
   PTC_Checkbox1:SetChecked(1)
   addonTable:OptionChanged()
  end
 end)
 addon_stuff.anchorframe:SetScript("OnHide", function(self)
  if self.isMoving then
   addon_stuff.anchorframe:StopMovingOrSizing()
   addon_stuff.anchorframe.isMoving = false
  end
 end)

 addon_stuff["hps"].frame = createbar()
 addon_stuff["hps"].frame:SetPoint("TOPLEFT", addon_stuff.anchorframe, "BOTTOMLEFT")
 addon_stuff["hps"].frame.foreground:SetTexture(0,1,0,1)
 addon_stuff["hps"].frame:SetScript("OnUpdate", function() BarUpdate("hps") end)
 
 addon_stuff["dps"].frame = createbar()
 addon_stuff["dps"].frame:SetPoint("LEFT", addon_stuff["hps"].frame, "RIGHT")
 addon_stuff["dps"].frame.foreground:SetTexture(1,0,0,1)
 addon_stuff["dps"].frame:SetScript("OnUpdate", function() BarUpdate("dps") end)
end

local function SlashCmd(arg)
 if arg == "config" then
  InterfaceOptionsFrame_OpenToCategory(PTracker.panel)
 else
  if PTracker_Saves.enabled then
   PTracker_Saves.enabled = nil
   print("|cffFF0000Panic Tracker: Disabled|r")
  else
   PTracker_Saves.enabled = 1
   print("|cff00FF00Panic Tracker: Enabled|r")
  end
  PTC_Checkbox0:SetChecked(PTracker_Saves.enabled)
  addonTable:OptionChanged()
 end
end

local function Process(q, arg) 
 if not addon_stuff[arg] then return end
 local result = {}
 result.t = GetTime() + PTracker_Saves.range
 result.q = q
 table.insert(addon_stuff[arg].list, result)
end

local lastorientation = 2
local function SetupBars()

 if not PTracker_Saves.enabled then
  addon_stuff["dps"].frame:Hide()
  addon_stuff["hps"].frame:Hide()
  addon_stuff.anchorframe:Hide()
  return
 end

 addon_stuff["dps"].frame:Show()
 addon_stuff["hps"].frame:Show()
 addon_stuff.anchorframe:SetPoint(unpack(PTracker_Saves.anchor))
 if not PTracker_Saves.locked then 
  addon_stuff.anchorframe:Show()
  addon_stuff["dps"].frame:Show()
  addon_stuff["hps"].frame:Show()
 elseif PTracker_Saves.hideoutofcombat and not InCombatLockdown() then
  addon_stuff["dps"].frame:Hide()
  addon_stuff["hps"].frame:Hide()
  addon_stuff.anchorframe:Hide()
 else
  addon_stuff.anchorframe:Hide()
 end
 if PTracker_Saves.orientation ~= lastorientation then
  if PTracker_Saves.orientation then
   addon_stuff["dps"].frame:ClearAllPoints()
   addon_stuff["dps"].frame:SetPoint("LEFT", addon_stuff["hps"].frame, "RIGHT")
   addon_stuff["dps"].frame:SetWidth(25)
   addon_stuff["hps"].frame:SetWidth(25)
   addon_stuff["dps"].frame:SetHeight(206)
   addon_stuff["hps"].frame:SetHeight(206)
   addon_stuff["hps"].frame.foreground:ClearAllPoints()
   addon_stuff["dps"].frame.foreground:ClearAllPoints()
   addon_stuff["hps"].frame.foreground:SetPoint("BOTTOMLEFT", addon_stuff["hps"].frame, "BOTTOMLEFT", 3, 3)
   addon_stuff["hps"].frame.foreground:SetPoint("BOTTOMRIGHT", addon_stuff["hps"].frame, "BOTTOMRIGHT", -3, 3)
   addon_stuff["dps"].frame.foreground:SetPoint("BOTTOMLEFT", addon_stuff["dps"].frame, "BOTTOMLEFT", 3, 3)
   addon_stuff["dps"].frame.foreground:SetPoint("BOTTOMRIGHT", addon_stuff["dps"].frame, "BOTTOMRIGHT", -3, 3)
   addon_stuff.anchorframe:SetSize(addon_stuff["dps"].frame:GetWidth() + addon_stuff["hps"].frame:GetWidth(), 40)
  else
   addon_stuff["dps"].frame:ClearAllPoints()
   addon_stuff["dps"].frame:SetPoint("TOP", addon_stuff["hps"].frame, "BOTTOM")
   addon_stuff["dps"].frame:SetHeight(25)
   addon_stuff["hps"].frame:SetHeight(25)
   addon_stuff["dps"].frame:SetWidth(206)
   addon_stuff["hps"].frame:SetWidth(206)
   addon_stuff["hps"].frame.foreground:ClearAllPoints()
   addon_stuff["dps"].frame.foreground:ClearAllPoints()
   addon_stuff["hps"].frame.foreground:SetPoint("BOTTOMLEFT", addon_stuff["hps"].frame, "BOTTOMLEFT", 3, 3)
   addon_stuff["hps"].frame.foreground:SetPoint("TOPLEFT", addon_stuff["hps"].frame, "TOPLEFT", 3, -3)
   addon_stuff["dps"].frame.foreground:SetPoint("BOTTOMLEFT", addon_stuff["dps"].frame, "BOTTOMLEFT", 3, 3)
   addon_stuff["dps"].frame.foreground:SetPoint("TOPLEFT", addon_stuff["dps"].frame, "TOPLEFT", 3, -3)
   addon_stuff.anchorframe:SetSize(addon_stuff["hps"].frame:GetWidth(), 40)
  end
  lastorientation = PTracker_Saves.orientation
 end
end

function addonTable:OptionChanged()
 SetupBars()
end

--[[
SWING_DAMAGE: amount, school, resisted, blocked, absorbed, critical, glancing, crushing
RANGE_DAMAGE: spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing
SPELL_DAMAGE: spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing
SPELL_PERIODIC_DAMAGE: spellId, spellName, spellSchool, amount, school, resisted, blocked, absorbed, critical, glancing, crushing
]]

-- event handler
local eventframe = CreateFrame("FRAME","PTEventFrame")
eventframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
eventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
eventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
eventframe:RegisterEvent("VARIABLES_LOADED")
local function eventhandler(self, event, ...)
 if event == "COMBAT_LOG_EVENT_UNFILTERED" then
  local timestamp, e = ...
  local destName = select(9, ...)
  if destName == UnitName("PLAYER") then
   if string.find(e,"_DAMAGE") then
    local dam = select(e == "SWING_DAMAGE" and 12 or 15, ...)
	Process(dam, "dps")
   elseif string.find(e,"_HEAL") then
    local dam = select(15, ...)
	Process(dam, "hps")
   end
  end
 elseif event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED" then
  SetupBars()
 elseif event == "VARIABLES_LOADED" then
  if not PTracker_Saves then PTracker_Saves = {} end
  if not PTracker_Saves.anchor then
   PTracker_Saves.anchor = {"TOPLEFT", nil, "TOPLEFT", 100, -100}
  end
  if not PTracker_Saves.range then PTracker_Saves.range = 2 end
  GenerateBars()
  addonTable:SetupConfigFrame()
  SetupBars()
 end
end
eventframe:SetScript("OnEvent", eventhandler)

-- slash commands
SLASH_PTracker1 = "/pt"
SLASH_PTracker2 = "/ptracker"
SlashCmdList["PTracker"] = SlashCmd